Subject: Re: [PATCH] NET: Multiqueue network device support.

From: jamal <[email-masked]>
Date: Mon, 11 Jun 2007 11:25:49 -0400

On Mon, 2007-11-06 at 17:12 +0200, Patrick McHardy wrote:

> > Ok, so let me revert that; 0 is higher prio than n-1.
> 
> 
> Yes.
> 

Ok, gotcha.
 
> > "possibly long time" is where we diverge ;->
> 
> Worst cast is (n - 2) * (m - 1) + 1 full sized packet transmission
> times.
> 
> You can do the math yourself, but we're talking about potentially
> a lot of packets.

I agree if you use the strategy of "a ring shutdown down" implies
"dont wake up until the ring that caused the shutdown opens up"
What i am saying below is to make a change to that strategy.

> > If you throw the burden to the driver (as i am recommending in all my
> > arguements so far), it should open up sooner based on priorities.
> > I didnt wanna bring this earlier because it may take the discussion in
> > the wrong direction. 
> > So in your example if n-1 shuts down the driver, then it is upto to the
> > driver to open it up if any higher prio packet makes it out.
> 
> 
> How could it do that? n-1 is still completely full and you don't
> know what the next packet is going to be. Are you proposing to
> simply throw the packet away in the driver even though its within
> the configured limits of the qdisc?

No no Patrick - i am just saying the following:
- let the driver shutdown whenever a ring is full. Remember which ring X
shut it down.
- when you get a tx interupt or prun tx descriptors, if a ring <= X has
transmitted a packet (or threshold of packets), then wake up the driver
(i.e open up). 
In the meantime packets from the stack are sitting on the qdisc and will
be sent when the driver opens up.

Anyways, I have to run to work; thanks for keeping the discussion at the
level you did.

cheers,
jamal